diff --git a/.gitignore b/.gitignore
index 2acb45975..5f20b8716 100644
--- a/.gitignore
+++ b/.gitignore
@@ -10,6 +10,8 @@ doc/guides/cryptodevs/overview_aead_table.txt
 doc/guides/cryptodevs/overview_asym_table.txt
 doc/guides/compressdevs/overview_feature_table.txt
 doc/guides/vdpadevs/overview_feature_table.txt
+doc/guides/eventdevs/overview_feature_table.txt
+doc/guides/eventdevs/overview_adptr_feature_table.txt
 
 # ignore generated ctags/cscope files
 cscope.out.po
diff --git a/doc/guides/conf.py b/doc/guides/conf.py
index c368fa51d..a49402b64 100644
--- a/doc/guides/conf.py
+++ b/doc/guides/conf.py
@@ -47,7 +47,7 @@
 master_doc = 'index'
 
 # Maximum feature description string length
-feature_str_len = 25
+feature_str_len = 45
 
 # Figures, tables and code-blocks automatically numbered if they have caption
 numfig = True
@@ -406,6 +406,16 @@ def setup(app):
                             'Features',
                             'Features availability in vDPA drivers',
                             'Feature')
+    table_file = dirname(__file__) + '/eventdevs/overview_feature_table.txt'
+    generate_overview_table(table_file, 1,
+                            'Features',
+                            'Features availability in eventdev drivers',
+                            'Feature')
+    table_file = dirname(__file__) + '/eventdevs/overview_adptr_feature_table.txt'
+    generate_overview_table(table_file, 2,
+                            'Adapter Features',
+                            'Features availability for adapters',
+                            'Feature')
 
     if LooseVersion(sphinx_version) < LooseVersion('1.3.1'):
         print('Upgrade sphinx to version >= 1.3.1 for '
diff --git a/doc/guides/eventdevs/features/default.ini b/doc/guides/eventdevs/features/default.ini
new file mode 100644
index 000000000..d007d7a69
--- /dev/null
+++ b/doc/guides/eventdevs/features/default.ini
@@ -0,0 +1,30 @@
+;
+; Features of a default eventdev driver.
+;
+; This file defines the features that are valid for inclusion in
+; the other driver files and also the order that they appear in
+; the features table in the documentation.
+;
+[Features]
+Event queue priority based scheduling =
+Event priority based scheduling       =
+Event device distributed scheduling   =
+Event device non sequential mode      =
+Event queue all types                 =
+Burst mode enqueue/dequeue            =
+Event port implicit release disable   =
+Runtime event queue/port linking      =
+Multi queue linking per port          =
+
+;
+; Features of a default adapter.
+;
+[Adapter Features]
+Eth Rx/Tx adapter on internal port         =
+Multiple event queues per ethdev           =
+Override flow ID                           =
+Crypto adapter new event enqueue           =
+Crypto adapter forwarded event enqueue     =
+Crypto queue pair mapping to event queue   =
+Crypto adapter session data store/retrieve =
+Timer adapter support in H/W               =
diff --git a/doc/guides/eventdevs/features/dpaa.ini b/doc/guides/eventdevs/features/dpaa.ini
new file mode 100644
index 000000000..3cf172f40
--- /dev/null
+++ b/doc/guides/eventdevs/features/dpaa.ini
@@ -0,0 +1,8 @@
+;
+; Supported features of the 'dpaa' eventdev driver.
+;
+; Refer to default.ini for the full list of available PMD features.
+;
+[Features]
+
+[Adapter Features]
diff --git a/doc/guides/eventdevs/features/dpaa2.ini b/doc/guides/eventdevs/features/dpaa2.ini
new file mode 100644
index 000000000..822a82ef3
--- /dev/null
+++ b/doc/guides/eventdevs/features/dpaa2.ini
@@ -0,0 +1,8 @@
+;
+; Supported features of the 'dpaa2' eventdev driver.
+;
+; Refer to default.ini for the full list of available PMD features.
+;
+[Features]
+
+[Adapter Features]
diff --git a/doc/guides/eventdevs/features/dsw.ini b/doc/guides/eventdevs/features/dsw.ini
new file mode 100644
index 000000000..230737045
--- /dev/null
+++ b/doc/guides/eventdevs/features/dsw.ini
@@ -0,0 +1,8 @@
+;
+; Supported features of the 'distributed software' eventdev driver.
+;
+; Refer to default.ini for the full list of available PMD features.
+;
+[Features]
+
+[Adapter Features]
diff --git a/doc/guides/eventdevs/features/octeontx.ini b/doc/guides/eventdevs/features/octeontx.ini
new file mode 100644
index 000000000..d1b1fe6d6
--- /dev/null
+++ b/doc/guides/eventdevs/features/octeontx.ini
@@ -0,0 +1,8 @@
+;
+; Supported features of the 'octeontx' eventdev driver.
+;
+; Refer to default.ini for the full list of available PMD features.
+;
+[Features]
+
+[Adapter Features]
diff --git a/doc/guides/eventdevs/features/octeontx2.ini b/doc/guides/eventdevs/features/octeontx2.ini
new file mode 100644
index 000000000..96f1af0dc
--- /dev/null
+++ b/doc/guides/eventdevs/features/octeontx2.ini
@@ -0,0 +1,8 @@
+;
+; Supported features of the 'octeontx2' eventdev driver.
+;
+; Refer to default.ini for the full list of available PMD features.
+;
+[Features]
+
+[Adapter Features]
diff --git a/doc/guides/eventdevs/features/opdl.ini b/doc/guides/eventdevs/features/opdl.ini
new file mode 100644
index 000000000..020808fce
--- /dev/null
+++ b/doc/guides/eventdevs/features/opdl.ini
@@ -0,0 +1,8 @@
+;
+; Supported features of 'Ordered Packet Distribution Library' eventdev driver.
+;
+; Refer to default.ini for the full list of available PMD features.
+;
+[Features]
+
+[Adapter Features]
diff --git a/doc/guides/eventdevs/features/sw.ini b/doc/guides/eventdevs/features/sw.ini
new file mode 100644
index 000000000..a5789f56d
--- /dev/null
+++ b/doc/guides/eventdevs/features/sw.ini
@@ -0,0 +1,8 @@
+;
+; Supported features of the 'software' eventdev driver.
+;
+; Refer to default.ini for the full list of available PMD features.
+;
+[Features]
+
+[Adapter Features]
diff --git a/doc/guides/eventdevs/index.rst b/doc/guides/eventdevs/index.rst
index 570905b81..540ac762c 100644
--- a/doc/guides/eventdevs/index.rst
+++ b/doc/guides/eventdevs/index.rst
@@ -11,6 +11,7 @@ application trough the eventdev API.
     :maxdepth: 2
     :numbered:
 
+    overview
     dpaa
     dpaa2
     dsw
diff --git a/doc/guides/eventdevs/overview.rst b/doc/guides/eventdevs/overview.rst
new file mode 100644
index 000000000..6825b9007
--- /dev/null
+++ b/doc/guides/eventdevs/overview.rst
@@ -0,0 +1,19 @@
+..  SPDX-License-Identifier: BSD-3-Clause
+    Copyright(C) 2019 Marvell International Ltd.
+
+Event Device Supported Functionality Matrices
+=============================================
+
+Event Device Supported Feature Flags
+------------------------------------
+
+.. _table_eventdev_pmd_features:
+
+.. include:: overview_feature_table.txt
+
+Adapter Supported Feature Flags
+-------------------------------
+
+.. _table_adapter_features:
+
+.. include:: overview_adptr_feature_table.txt